--[[ MinimapSquare
     Work in progress
  ]]

if not FixR then return end

local DefaultO = {
  ["MMButtonsHidden"] = false;
  ["WatchFrameHidden"] = false;
}
local misc = {
  ["desc"] = "Work in progress";
}

local M = FixR:NewModule("MinimapSquare", DefaultO, misc)

FixR_MinimapSquare_Button = CreateFrame("Frame", "FixR_MinimapSquare_Button", UIParent)
local frame, framePanel
local bgTexFrame
local frameEvents = {};
local _G = _G
local min = min
local max = max
local sin = math.sin

function frameEvents:UPDATE_PENDING_MAIL(...)
  self:updateMailIcon()
end
function frameEvents:MAIL_CLOSED(...)
  --START of some code from Postal
  for i = 1, GetInboxNumItems() do
    if not select(9, GetInboxHeaderInfo(i)) then
      self:updateMailIcon()
      return
    end
  end
  --END of some code from Postal
  self:updateMailIcon(true)
end
--CALENDAR_UPDATE_INVITE_LIST
--CALENDAR_UPDATE_EVENT
function frameEvents:CALENDAR_UPDATE_EVENT_LIST()
  self:updateCalenderIcon()
end
function frameEvents:CALENDAR_UPDATE_PENDING_INVITES()
  self:updateCalenderIcon()
end
function frameEvents:LFG_LIST_ACTIVE_ENTRY_UPDATE()
  self:updateNewApplicationIcon()
end
function frameEvents:LFG_LIST_APPLICANT_UPDATED()
  self:updateNewApplicationIcon()
end

local function initFrame()
  local frameSize = 30
  
  frame = FixR_MinimapSquare_Button
  --frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 200, 100)
  frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 162, 54)
  frame:SetFrameStrata("LOW")
  frame:SetSize(frameSize, frameSize)
  frame:Show()
  --fixrMinimapSquare0x01 = frame
  
  frame.bgtexture = frame:CreateTexture(nil, "BORDER")
  frame.bgtexture:SetTexture("Interface\\Addons\\FixR\\graphics\\fixrround")
  frame.bgtexture:SetSize(frameSize-4, frameSize-4)
  frame.bgtexture:SetPoint("TOPLEFT", 2, -2)
  
  frame.buttonTexture = frame:CreateTexture(nil, "ARTWORK")
  frame.buttonTexture:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
  frame.buttonTexture:SetSize(52, 52)
  frame.buttonTexture:SetPoint("TOPLEFT")
  frame.buttonTexture:Show()
  
  frame:EnableMouse(true)
  frame.timeSinceLastUpdate = 0
  frame.timerInterval = 5
  frame.flash_NewEventIcon = false
  frame.flash_NewEventIcon_Timer = 0
  frame.flash_NewEventIcon_TimerMax = 2
  frame.flash_NewEventIcon_IndexMax = 2*PI
  
  frame.BlizMinimapFrame = nil
  frame.BlizMinimapBackdropFrame = _G["MinimapBackdrop"]
  --children of MinimapBackdrop:
  frame.BlizMinimapBackdropFrame_HideChildren = {
    "MinimapZoomOut",
    "MinimapZoomIn",
    "MiniMapWorldMapButton",
  };
  for i, v in pairs(frame.BlizMinimapBackdropFrame_HideChildren) do
    local f = _G[v]
    if f then
      f:Hide()
    end
  end
  
  frame.BlizWatchFrame = _G["ObjectiveTrackerFrame"]
  --[[
  --/run local f=ObjectiveTrackerFrame;f:ClearAllPoints();f:SetParent(UIParent);f:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -10, 300)

  --/run local f=ObjectiveTrackerFrame;f:ClearAllPoints();f:SetParent(UIParent);f:SetPoint("CENTER", UIParent, "CENTER", -10, 300)
  --/dump ObjectiveTrackerFrame:GetPoint()
  --/run local f=ObjectiveTrackerFrame;f:ClearAllPoints();f:SetPoint("TOPRIGHT", f:GetParent(), "BOTTOMRIGHT", -10, -10)
  frame.BlizWatchFrame:ClearAllPoints()
  frame.BlizWatchFrame:SetParent(UIParent)
  frame.BlizWatchFrame:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -10, 300)
  
  MinimapCluster:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", 0, 100)
  parent=ObjectiveTrackerFrame?
  --]]
  
  frame:SetScript("OnEvent", function(self, event, ...)
    frameEvents[event](self, ...); -- call one of the event functions
  end);
  frame:SetScript("OnEnter", function(self, event, ...)
    if QueueStatusFrame and QueueStatusFrame:GetParent() == self and QueueStatusMinimapButton and QueueStatusMinimapButton:IsShown() then
      QueueStatusFrame:Show()
    end
  end);
  frame:SetScript("OnLeave", function(self, event, ...)
    if QueueStatusFrame and QueueStatusFrame:GetParent() == self then
      QueueStatusFrame:Hide()
    end
  end);
  frame:SetScript("OnUpdate", function(self, elapsed)
    self.OnUpdate(self, elapsed)
  end);
  frame.toggleButtonPanel = function(self, blnShow)
    if blnShow then
      framePanel:Show()
    else
      framePanel:Hide()
    end
    M.O["MMButtonsHidden"] = (blnShow == false) or false
  end
  frame.toggleBlizWatchFrame = function(self, blnShow)
    if blnShow then
      self.BlizWatchFrame:Show()
    else
      self.BlizWatchFrame:Hide()
    end
    M.O["WatchFrameHidden"] = (blnShow == false) or false
  end
  frame:SetScript("OnMouseDown", function(self, button)
    if button == "LeftButton" then
      if IsShiftKeyDown() then
        if framePanel:IsShown() then
          self:toggleButtonPanel(false)
        else
          self:toggleButtonPanel(true)
        end
      elseif IsAltKeyDown() then
        if self.BlizWatchFrame:IsShown() then
          self:toggleBlizWatchFrame(false)
        else
          self:toggleBlizWatchFrame(true)
        end
      end
    end
  end);
  frame.OnUpdate = function(self, elapsed)
    self.timeSinceLastUpdate = self.timeSinceLastUpdate + elapsed
    while (self.timeSinceLastUpdate > self.timerInterval) do --in seconds
      framePanel:setChildren(self.BlizMinimapFrame:GetChildren())
      framePanel:setChildren(self.BlizMinimapBackdropFrame:GetChildren())
      framePanel:updateChildrenPositions()
      
      self.timeSinceLastUpdate = self.timeSinceLastUpdate - self.timerInterval
    end
    
    if self.flash_NewEventIcon then
      self.flash_NewEventIcon_Timer = self.flash_NewEventIcon_Timer + elapsed
      if self.flash_NewEventIcon_Timer > self.flash_NewEventIcon_TimerMax then
        self.flash_NewEventIcon_Timer = self.flash_NewEventIcon_Timer - self.flash_NewEventIcon_TimerMax
      end
      self.newEventIcon:SetAlpha(max(0, 0.5 + 0.5*sin(self.flash_NewEventIcon_Timer / self.flash_NewEventIcon_TimerMax * self.flash_NewEventIcon_IndexMax)))
    end
    
    --queue:"OpenCalendar()"
    if self.timer_OpenCalendar >= 0 then
      self.timer_OpenCalendar = self.timer_OpenCalendar - elapsed
      if self.timer_OpenCalendar <= 0 then
        self.timer_OpenCalendar = -1
        OpenCalendar()
      end
    end
  end
  frame.updateMailIcon = function(self, forceHideIcon)
    if forceHideIcon then
      self.newMailIcon:Hide()
    else
      if self.newMailIcon then
        if HasNewMail() then
          self.newMailIcon:Show()
        else
          self.newMailIcon:Hide()
        end
      end
    end
  end
  frame.updateCalenderIcon = function(self)
    if self.newEventIcon then
      local invites = CalendarGetNumPendingInvites()
      --eventIndex = CalendarGetFirstPendingInvite([-1, 0, 1], monthDay)
      --numEvents = CalendarGetNumDayEvents([-1, 0, 1], monthDay)
      --title, hour, minute, calendarType, sequenceType, eventType, texture, modStatus, inviteStatus, invitedBy, difficulty, inviteType, sequenceIndex, numSequenceDayss = CalendarGetDayEvent(monthOffset, day, eventIndex)
      
--[[
local presentWeekday, presentMonth, presentDay, presentYear = CalendarGetDate();
local prevMonth, prevYear, prevNumDays = CalendarGetMonth(-1);
local nextMonth, nextYear, nextNumDays = CalendarGetMonth(1);
local month, year, numDays, firstWeekday = CalendarGetMonth();
--]]
      if invites > 0 then
        self.newEventIcon:Show()
        --local presentWeekday, presentMonth, presentDay, presentYear = CalendarGetDate()
        local _, _, presentDay, _ = CalendarGetDate()
        --local month, year, numDays, firstWeekday = CalendarGetMonth()
        local _, _, numDays, _ = CalendarGetMonth()
        --local nextMonth, nextYear, nextNumDays = CalendarGetMonth(1)
        local blnFlashIcon = false
        local checkDay, checkMonth, daysChecked = presentDay, 0, 0
        while (daysChecked < 6) and (blnFlashIcon == false) do
          local eventIndex = CalendarGetFirstPendingInvite(checkMonth, checkDay) --this might only return values greater than zero after "OpenCalendar()"
          if eventIndex > 0 then
            blnFlashIcon = true
          else
            checkDay = checkDay + 1
            if checkDay > numDays then
              checkDay = 1
              checkMonth = 1
            end
          end
          daysChecked = daysChecked + 1
        end
        if blnFlashIcon then
          self.flash_NewEventIcon = true
          self.flash_NewEventIcon_Timer = 0
        else
          self.flash_NewEventIcon = false
          self.newEventIcon:SetAlpha(1)
        end
      else
        self.newEventIcon:Hide()
        self.flash_NewEventIcon = false
      end
    end
  end
  frame.updateNewApplicationIcon = function(self)
    local apps = C_LFGList.GetApplicants()
    if not apps then
      self.newApplicationIcon:Hide()
      return
    end
    local num = 0
    for i = 1, #apps do
      local status = select(2, C_LFGList.GetApplicantInfo(apps[i]))
      if status == "applied" then
        num = num + 1
      end
    end
    if num > 0 then
      self.newApplicationIcon:Show()
    else
      self.newApplicationIcon:Hide()
    end
  end
  
  framePanel = CreateFrame("Frame", "FixR_MinimapSquare_Panel", frame)
  framePanel:SetPoint("TOPLEFT", frame, "TOPRIGHT", 0, 0)
  framePanel:SetFrameStrata("LOW")
  framePanel:SetSize(40, 40)
  framePanel:Show()
  
  --[[
  framePanel.texture = framePanel:CreateTexture()
  framePanel.texture:SetAllPoints(framePanel)
  framePanel.texture:SetColorTexture(1, 0.67, 0.67, 1)
  --]]
  
  framePanel.listChildren = {}
  framePanel.listLength = 0
  
  --no border
  local fCluster = _G["MinimapCluster"]
  local fBackdrop = _G["MinimapBackdrop"]
  fBackdrop:Hide()
  fBackdrop:SetParent(fCluster)
  
  --square minimap
  frame.BlizMinimapFrame = _G["Minimap"]
  frame.BlizMinimapFrame:SetMaskTexture("Interface\\Buttons\\White8x8")
  frame.BlizMinimapFrame:SetParent(UIParent)
  frame.BlizMinimapFrame:ClearAllPoints()
  frame.BlizMinimapFrame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 10, 7) --10 right, 7 up
  frame.BlizMinimapFrame:SetSize(148,148)
  
  --Garrison Button
  GarrisonLandingPageMinimapButton:SetParent(frame)
  GarrisonLandingPageMinimapButton:ClearAllPoints()
  GarrisonLandingPageMinimapButton:SetPoint("TOPLEFT", frame, "BOTTOMLEFT", 0, 0)
  GarrisonLandingPageMinimapButton:SetSize(frameSize, frameSize)
  
  --Minimap Difficulties
  local fMMDifficulties = {"MiniMapChallengeMode", "MiniMapInstanceDifficulty", "GuildInstanceDifficulty"}; --Parent: MinimapCluster
  for i, v in ipairs(fMMDifficulties) do
    local f2 = _G[v]
    if f2 then
      f2:SetParent(UIParent)
      f2:ClearAllPoints()
      if i == 1 then
        f2:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", 6, 155-6) --x="28" y="-23"
      else
        f2:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", 0, 155) --x="22" y="-17"
      end
    end
  end
  
  fCluster:Hide()
  
  
  framePanel.setChildren = function(self, ...)
    local maxChildren = select("#", ...)
    local numChildren = self.listLength
    for i = 1, maxChildren do
      local nextChild = select(i, ...)
      if true then --if nextChild:IsShown() then --add them anyway, could be temporarily hidden
        nextChild:SetParent(self)
        nextChild:ClearAllPoints()
        --nextChild:SetPoint("TOPLEFT", self, "TOPLEFT", (numChildren * 32), 0)
        --width=31, GameTimeFrame:40
        nextChild:SetSize(31,31)
        numChildren = numChildren + 1
        
        self.listChildren[numChildren] = nextChild
      end
    end
    self.listLength = numChildren
  end
  
  framePanel.updateChildrenPositions = function(self)
    local num = 0
    for i, v in ipairs(self.listChildren) do
      if v.IsShown and v:IsShown() then
        --self.listChildren[k] = 1
        v:SetPoint("TOPLEFT", self, "TOPLEFT", (num * 32), 0)
        num = num + 1
      else
        --self.listChildren[k] = 0
      end
    end
  end
  
  local tex = frame:CreateTexture(nil, "OVERLAY")
  tex:SetTexture("Interface\\Icons\\INV_Letter_15")
  tex:SetSize(14, 14)
  tex:SetPoint("TOPRIGHT")
  tex:Hide()
  frame.newMailIcon = tex
  
  local tex2 = frame:CreateTexture(nil, "OVERLAY")
  tex2:SetTexture("Interface\\Calendar\\EventNotification")
  tex2:SetSize(14, 16)
  tex2:SetPoint("BOTTOMRIGHT", 5, -3)
  tex2:Hide()
  frame.newEventIcon = tex2
  
  local tex3 = frame:CreateTexture(nil, "OVERLAY")
  tex3:SetTexture("Interface\\QuestFrame\\QuestTypeIcons")
  tex3:SetTexCoord(unpack(QUEST_TAG_TCOORDS[QUEST_TAG_GROUP]))
  tex3:SetSize(14, 14)
  tex3:SetPoint("TOPLEFT", 0, 0)
  tex3:Hide()
  frame.newApplicationIcon = tex3
  
  --delay the first call of OpenCalendar() by 5 sec
  frame.timer_OpenCalendar = 5
  
  ----------------------------------------
  --background textures
  ----------------------------------------
  
  bgTexFrame = CreateFrame("Frame", nil, UIParent)
  bgTexFrame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 0, 0)
  bgTexFrame:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 0, 0)
  bgTexFrame:SetHeight(200)--doesn't matter
  bgTexFrame:SetFrameStrata("BACKGROUND")
  bgTexFrame:SetFrameLevel(2)
  
  bgTexFrame.bgtextures = {};
  
  local texturesConfig = {
    {400, 200,   0, 0,  "BOTTOMLEFT",  "BOTTOMLEFT", "BACKGROUND", -1,      "unten_links_tga"};
    {400, 200, 220, 0,  "BOTTOMLEFT",  "BOTTOMLEFT", "BACKGROUND",  0, "unten_mittelteil_tga"};
    {400, 200, 550, 0,  "BOTTOMLEFT",  "BOTTOMLEFT", "BACKGROUND",  1, "unten_mittelteil_tga"};
    {400, 200, 880, 0,  "BOTTOMLEFT",  "BOTTOMLEFT", "BACKGROUND",  1, "unten_mittelteil_tga"};
    {400, 200,   0, 0, "BOTTOMRIGHT", "BOTTOMRIGHT", "BACKGROUND",  1,     "unten_rechts_tga"};
  };
  for i, v in ipairs(texturesConfig) do
    local tex = bgTexFrame:CreateTexture(nil, v[7])
    tex:SetSize(v[1], v[2])
    tex:SetPoint(v[5], bgTexFrame, v[6], v[3], v[4])
    tex:SetDrawLayer(v[7], v[8])
    tex:SetTexture("Interface\\Addons\\FixR\\graphics\\"..v[9])
    
    table.insert(bgTexFrame.bgtextures, tex)
  end
  
  --bring chatframe back to top
  ChatFrame1:SetFrameLevel(7)
  
  do
--[[
Show:
/run local r,n,f=random,255;f=function(a)a.z9_=a.z9_ or a:CreateTexture(nil,"OVERLAY");a.z9_:SetAllPoints();a.z9_:SetTexture(r(n)/n,r(n)/n,r(n)/n,0.3);a.z9_:Show();for i=1,select("#",a:GetChildren())do f(select(i,a:GetChildren()))end;end;f(UIParent)
Hide:
/run local r,n,f=random,255;f=function(a)a.z9_=a.z9_ or a:CreateTexture(nil,"OVERLAY");a.z9_:SetAllPoints();a.z9_:SetTexture(r(n)/n,r(n)/n,r(n)/n,0.3);a.z9_:Hide();for i=1,select("#",a:GetChildren())do f(select(i,a:GetChildren()))end;end;f(UIParent)

FixR_MinimapSquare_F = f
/run FixR_MinimapSquare_F(UIParent:GetChildren())
--]]
  end
end

function M:Load()
  if frame == nil then  
    initFrame()
  end
  for k, v in pairs(frameEvents) do
    frame:RegisterEvent(k); -- Register all events for which handlers have been defined
  end
  frame:Show()
  if M.O["MMButtonsHidden"] then
    frame:toggleButtonPanel(false)
  end
  if M.O["WatchFrameHidden"] then
    frame:toggleBlizWatchFrame(false)
  end
  frame:updateMailIcon()
  frame:updateCalenderIcon()
  SetCVar("cameraDistanceMaxFactor", 3.4) --default = 2
end
function M:Unload()
  if frame then
    for k, v in pairs(frameEvents) do
      frame:UnregisterEvent(k); -- Unregister all events for which handlers have been defined
    end
    frame:Hide()
    --TexFrame:Hide()
  end
end

function M:SetOption(arg1, arg2)
end